require "emvoicer/services/blinksale/parsing"

module Emvoicer
  module Services
    class Blinksale < Emvoicer::Services::HttpAuth
      extend BlinksaleParsing

      attr_reader :subdomain, :username, :password

      def initialize(subdomain, username, password)
        @subdomain = subdomain
        @username = username
        @password = password
      end

      def auth_params
        [username, password]
      end

      def headers
        {
          "Content-Type" => "application/vnd.blinksale+xml",
          "Accept" => "application/vnd.blinksale+xml"
        }
      end

      def base_url
        "https://#{ subdomain }.blinksale.com"
      end

      def invoices_url
        base_url + "/invoices"
      end

      def client_url(id)
        base_url + "/clients/#{ id }"
      end

      def self.test_authentication_response(response)
        case response
        when Net::HTTPSuccess then true
        else
          false
        end
      end
    end
  end
end
