require "net/http"
require "uri"

module Emvoicer
  module Services
    class HttpAuth < Emvoicer::Services::Base
      def request_headers
        super.merge("Authorization" => auth_params)
      end

      def authentication_valid?
        url = URI.parse(invoices_url)
        request = Net::HTTP::Get.new(url.path)
        request.basic_auth *auth_params
        headers.each do |k, v|
          request[k] = v
        end
        http = Net::HTTP.new(url.host, url.port)
        http.use_ssl = true
        http.ca_file = "/etc/ssl/certs/ca-bundle.crt"
        response = http.start do |http|
          http.request(request)
        end
        self.class.test_authentication_response(response)
      end
    end
  end
end
